/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package be.grummfy.tools.nas.utils;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.util.Arrays;
import java.util.ResourceBundle;
import wol.configuration.EthernetAddress;
import wol.configuration.IllegalEthernetAddressException;

/**
 *
 * @author grummfy
 * @see WakeUpUtil.java from wol
 */
public class Wol
{
    private static ResourceBundle config = ResourceBundle.getBundle("be.grummfy.tools.nas.resources.Wol");

    public static Thread wakeUp()
    {
        Thread t = new Thread()
        {
            public void run()
            {
                try
                {
                    wakeMeUp();
                }
                catch (Exception $e)
                {
                    throw new RuntimeException($e);
                }
                finally
                {
                    this.stop();
                }
            }
        };
        return t;
    }

    protected static void wakeMeUp() throws IllegalEthernetAddressException, SocketException, IOException, InterruptedException
    {
        int loopUntil = getLoopUntil();
        DatagramSocket socket = new DatagramSocket();
        byte[] wakeupFrame = createWakeupFrame(getMac());
        DatagramPacket packet = new DatagramPacket(wakeupFrame, wakeupFrame.length, getHost(), getPort());
        for (int i = 0; i < loopUntil; i++)
        {
            System.out.println("send wakeup packets");
            socket.send(packet);
            Thread.sleep(750L);
        }
    }

    public static boolean isOnline() throws UnknownHostException, IOException
    {
        return getIp().isReachable(500);
    }

    private static int getLoopUntil()
    {
        return Integer.parseInt(config.getString("wol.loop"));
    }

    private static InetAddress getHost() throws UnknownHostException
    {
        return InetAddress.getByName(config.getString("host.host"));
    }
    
    private static InetAddress getIp() throws UnknownHostException
    {
        return InetAddress.getByName(config.getString("host.ip"));
    }
    
    private static EthernetAddress getMac() throws IllegalEthernetAddressException
    {
        return (new EthernetAddress(config.getString("host.mac")));
    }

    private static int getPort()
    {
        return Integer.parseInt(config.getString("host.port"));
    }
	
    /**
     * Creates the byte representation of a wakeupframe for the given ethernet address.
     * @see http://moldaner.de/wakeonlan/wakeonlan.html
     * 
     * @param ethernetAddress the ethernet address
     * 
     * @return a byte representation of the wakeupframe
     */
    protected static byte[] createWakeupFrame(EthernetAddress ethernetAddress)
    {
        byte[] ethernetAddressBytes = ethernetAddress.toBytes();
        byte[] wakeupFrame = new byte[6 + 16 * ethernetAddressBytes.length];

        Arrays.fill(wakeupFrame, 0, 6, (byte)0xFF);

        for (int j = 6; j < wakeupFrame.length; j += ethernetAddressBytes.length)
        {
            System.arraycopy(ethernetAddressBytes, 0, wakeupFrame, j, ethernetAddressBytes.length);
        }

        return wakeupFrame;
    }
}
